/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the EverflowConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &EverflowConnectorFormAllOf{}

// EverflowConnectorFormAllOf struct for EverflowConnectorFormAllOf
type EverflowConnectorFormAllOf struct {
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Label of the source
	Label *string `json:"label,omitempty"`
	// Report type
	ReportType *string `json:"reportType,omitempty"`
	// Columns
	Column []string `json:"column,omitempty"`
	// Time column
	TimeColumn *string `json:"timeColumn,omitempty"`
	// Timezone
	TimezoneId *string `json:"timezoneId,omitempty"`
	// Currency
	Currency *string `json:"currency,omitempty"`
	// Metrics
	Metric []string `json:"metric,omitempty"`
	// Data range expression
	DateRange *string `json:"dateRange,omitempty"`
}

// NewEverflowConnectorFormAllOf instantiates a new EverflowConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewEverflowConnectorFormAllOf() *EverflowConnectorFormAllOf {
	this := EverflowConnectorFormAllOf{}
	return &this
}

// NewEverflowConnectorFormAllOfWithDefaults instantiates a new EverflowConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewEverflowConnectorFormAllOfWithDefaults() *EverflowConnectorFormAllOf {
	this := EverflowConnectorFormAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *EverflowConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *EverflowConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetReportType returns the ReportType field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetReportType() string {
	if o == nil || IsNil(o.ReportType) {
		var ret string
		return ret
	}
	return *o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetReportTypeOk() (*string, bool) {
	if o == nil || IsNil(o.ReportType) {
		return nil, false
	}
	return o.ReportType, true
}

// HasReportType returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasReportType() bool {
	if o != nil && !IsNil(o.ReportType) {
		return true
	}

	return false
}

// SetReportType gets a reference to the given string and assigns it to the ReportType field.
func (o *EverflowConnectorFormAllOf) SetReportType(v string) {
	o.ReportType = &v
}

// GetColumn returns the Column field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetColumn() []string {
	if o == nil || IsNil(o.Column) {
		var ret []string
		return ret
	}
	return o.Column
}

// GetColumnOk returns a tuple with the Column field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetColumnOk() ([]string, bool) {
	if o == nil || IsNil(o.Column) {
		return nil, false
	}
	return o.Column, true
}

// HasColumn returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasColumn() bool {
	if o != nil && !IsNil(o.Column) {
		return true
	}

	return false
}

// SetColumn gets a reference to the given []string and assigns it to the Column field.
func (o *EverflowConnectorFormAllOf) SetColumn(v []string) {
	o.Column = v
}

// GetTimeColumn returns the TimeColumn field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetTimeColumn() string {
	if o == nil || IsNil(o.TimeColumn) {
		var ret string
		return ret
	}
	return *o.TimeColumn
}

// GetTimeColumnOk returns a tuple with the TimeColumn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetTimeColumnOk() (*string, bool) {
	if o == nil || IsNil(o.TimeColumn) {
		return nil, false
	}
	return o.TimeColumn, true
}

// HasTimeColumn returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasTimeColumn() bool {
	if o != nil && !IsNil(o.TimeColumn) {
		return true
	}

	return false
}

// SetTimeColumn gets a reference to the given string and assigns it to the TimeColumn field.
func (o *EverflowConnectorFormAllOf) SetTimeColumn(v string) {
	o.TimeColumn = &v
}

// GetTimezoneId returns the TimezoneId field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetTimezoneId() string {
	if o == nil || IsNil(o.TimezoneId) {
		var ret string
		return ret
	}
	return *o.TimezoneId
}

// GetTimezoneIdOk returns a tuple with the TimezoneId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetTimezoneIdOk() (*string, bool) {
	if o == nil || IsNil(o.TimezoneId) {
		return nil, false
	}
	return o.TimezoneId, true
}

// HasTimezoneId returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasTimezoneId() bool {
	if o != nil && !IsNil(o.TimezoneId) {
		return true
	}

	return false
}

// SetTimezoneId gets a reference to the given string and assigns it to the TimezoneId field.
func (o *EverflowConnectorFormAllOf) SetTimezoneId(v string) {
	o.TimezoneId = &v
}

// GetCurrency returns the Currency field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetCurrency() string {
	if o == nil || IsNil(o.Currency) {
		var ret string
		return ret
	}
	return *o.Currency
}

// GetCurrencyOk returns a tuple with the Currency field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetCurrencyOk() (*string, bool) {
	if o == nil || IsNil(o.Currency) {
		return nil, false
	}
	return o.Currency, true
}

// HasCurrency returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasCurrency() bool {
	if o != nil && !IsNil(o.Currency) {
		return true
	}

	return false
}

// SetCurrency gets a reference to the given string and assigns it to the Currency field.
func (o *EverflowConnectorFormAllOf) SetCurrency(v string) {
	o.Currency = &v
}

// GetMetric returns the Metric field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetMetric() []string {
	if o == nil || IsNil(o.Metric) {
		var ret []string
		return ret
	}
	return o.Metric
}

// GetMetricOk returns a tuple with the Metric field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetMetricOk() ([]string, bool) {
	if o == nil || IsNil(o.Metric) {
		return nil, false
	}
	return o.Metric, true
}

// HasMetric returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasMetric() bool {
	if o != nil && !IsNil(o.Metric) {
		return true
	}

	return false
}

// SetMetric gets a reference to the given []string and assigns it to the Metric field.
func (o *EverflowConnectorFormAllOf) SetMetric(v []string) {
	o.Metric = v
}

// GetDateRange returns the DateRange field value if set, zero value otherwise.
func (o *EverflowConnectorFormAllOf) GetDateRange() string {
	if o == nil || IsNil(o.DateRange) {
		var ret string
		return ret
	}
	return *o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *EverflowConnectorFormAllOf) GetDateRangeOk() (*string, bool) {
	if o == nil || IsNil(o.DateRange) {
		return nil, false
	}
	return o.DateRange, true
}

// HasDateRange returns a boolean if a field has been set.
func (o *EverflowConnectorFormAllOf) HasDateRange() bool {
	if o != nil && !IsNil(o.DateRange) {
		return true
	}

	return false
}

// SetDateRange gets a reference to the given string and assigns it to the DateRange field.
func (o *EverflowConnectorFormAllOf) SetDateRange(v string) {
	o.DateRange = &v
}

func (o EverflowConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o EverflowConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.ReportType) {
		toSerialize["reportType"] = o.ReportType
	}
	if !IsNil(o.Column) {
		toSerialize["column"] = o.Column
	}
	if !IsNil(o.TimeColumn) {
		toSerialize["timeColumn"] = o.TimeColumn
	}
	if !IsNil(o.TimezoneId) {
		toSerialize["timezoneId"] = o.TimezoneId
	}
	if !IsNil(o.Currency) {
		toSerialize["currency"] = o.Currency
	}
	if !IsNil(o.Metric) {
		toSerialize["metric"] = o.Metric
	}
	if !IsNil(o.DateRange) {
		toSerialize["dateRange"] = o.DateRange
	}
	return toSerialize, nil
}

type NullableEverflowConnectorFormAllOf struct {
	value *EverflowConnectorFormAllOf
	isSet bool
}

func (v NullableEverflowConnectorFormAllOf) Get() *EverflowConnectorFormAllOf {
	return v.value
}

func (v *NullableEverflowConnectorFormAllOf) Set(val *EverflowConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableEverflowConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableEverflowConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableEverflowConnectorFormAllOf(val *EverflowConnectorFormAllOf) *NullableEverflowConnectorFormAllOf {
	return &NullableEverflowConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableEverflowConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableEverflowConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
